## bindgen (aka bindings generator)

bindgen is a tool that automatically generated bindings for native go packages with 'goja'

Native Go packages are available [here](../../libs/)

Generated Output is available [here](../../generated/)

bindgen generates 3 different types of outputs 

- `go` => this directory contains corresponding goja bindings (actual bindings code) ex: [kerberos.go](../../generated/go/libkerberos/kerberos.go)
- `js` => this is more of a javascript **representation** of all exposed functions and types etc in javascript ex: [kerberos.js](../../generated/js/libkerberos/kerberos.js) and does not server any functional purpose other than reference
- `markdown` => autogenerated markdown documentation for each library / package ex: [kerberos.md](../../generated/markdown/libkerberos/kerberos.md)

